﻿Type=Activity
Version=1.60
FullScreen=True
IncludeTitle=True
@EndOfDesignText@
'	AdvancedExample activity
Sub Process_Globals
	Type ActivityState(SelectedIndex As Int, _
		X As Double, _
		Y As Double, _
		Zoom As Int)
		
	Type Image(IsLoaded As Boolean, _
		URL As String)
		
	Dim CurrentActivityState As ActivityState
	Dim Images(6) As Image
End Sub

Sub Globals
	Dim HtmlImageView As WebView
	Dim Spinner1 As Spinner
	Dim WebInterface As JSInterface
End Sub

Sub Activity_Create(FirstTime As Boolean)
	If FirstTime Then
		CurrentActivityState.Initialize
		
		Images(0).IsLoaded=False
		Images(0).URL="http://maps.google.com/maps/api/staticmap?center=51.178864,-1.826177&zoom=18&markers=size:small|color:blue|51.178865,-1.826230&maptype=satellite&size=640x640&sensor=false"
		Images(1).IsLoaded=False
		Images(1).URL="http://upload.wikimedia.org/wikipedia/commons/e/e4/Wells-next-the-Sea_lifeboat_station_by_Martin_Pearman.jpg"
		Images(2).IsLoaded=False
		Images(2).URL="http://upload.wikimedia.org/wikipedia/commons/4/46/Nobody_here_%27cept_us_chickens_-_geograph.org.uk_-_1805448.jpg"
		Images(3).IsLoaded=False
		Images(3).URL="file:///android_asset/eems_solar.jpg"
		Images(4).IsLoaded=False
		Images(4).URL="file:///android_asset/wells_harbour.jpg"
		Images(5).IsLoaded=False
		Images(5).URL="http://images1.fanpop.com/images/photos/2300000/The-Eiffel-Tower-paris-2393939-1920-2560.jpg"
	End If
	Activity.LoadLayout("LayoutAdvanced")
	
	For i=0 To Images.Length-1
		Spinner1.Add(Images(i).URL)
	Next
	Spinner1.SelectedIndex=CurrentActivityState.SelectedIndex
	
	'	addJSInterface will allow the WebView javascript to call B4A Subs in this activity
	WebInterface.addJSInterface(HtmlImageView, "B4A")
	
	HtmlImageView.LoadUrl("file:///android_asset/html_image_view_demo.htm?namespace=B4A&eventName=HtmlImageView")
End Sub

Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)
End Sub

Sub Spinner1_ItemClick (Position As Int, Value As Object)
	Dim Javascript As String
	
	If Images(Position).IsLoaded Then
		Javascript="htmlImageView.setViewState({imageURL:'"&Value&"', x:"&CurrentActivityState.X&", y:"&CurrentActivityState.Y&", zoom:"&CurrentActivityState.Zoom&"})"
	Else
		Javascript="htmlImageView.setViewState({imageURL:'"&Value&"'})"
	End If
	Log(Javascript)
	WebInterface.execJS(HtmlImageView, Javascript)
	
	Images(CurrentActivityState.SelectedIndex).IsLoaded=False
	CurrentActivityState.SelectedIndex=Position
	Images(CurrentActivityState.SelectedIndex).IsLoaded=True
End Sub

'	These Subs are the HtmlImageView javascript callbacks
'	They will only be called if you define a 'callback' object in the HtmlImageView constructor
'	The namespace "B4A" and eventName "HtmlImageView" have been defined in html_image_view_advanced.htm for this demo

Sub HtmlImageView_DOMReady
	'	The DOMReady event is triggered once all HtmlImageViewer DOM elements are initialised
	Log("HtmlImageView_DOMReady")
	Spinner1_ItemClick(Spinner1.SelectedIndex, Spinner1.SelectedItem)
End Sub

Sub HtmlImageView_Error(Message As String)
	'	The Error event is currently only triggered when an error occurs trying to load an image
	Log(Message)
End Sub

Sub HtmlImageView_StateChanged(X As String, Y As String, Zoom As String)
	'	The StateChanged event is triggered each time the HtmlImageView image is (re)drawn
	Log("HtmlImageView_StateChanged")
	CurrentActivityState.X=X
	CurrentActivityState.Y=Y
	CurrentActivityState.Zoom=Zoom
End Sub

